package net.pricefx.logic.core.model;

import com.fasterxml.jackson.databind.node.ObjectNode;
import net.pricefx.common.api.FormulaNature;
import net.pricefx.common.api.IFormulaNature;
import net.pricefx.pckg.transform.TransformCalculationLogic;
import net.pricefx.pckg.transform.descriptor.TypeDescriptor;

import java.util.Map;

public class PricingFormula extends AbstractFormula {

    public PricingFormula() {
    }

    public PricingFormula(ObjectNode element) {
        super(element);
    }

    @Override
    public AbstractFormulaElement createElement() {
        return new PricingFormulaElement();
    }

    @Override
    public AbstractFormulaElement createElement(Map value) {
        return new PricingFormulaElement(value);
    }


    @Override
    public final boolean isPricingLogic() {
        return true;
    }

    @Override
    public final boolean isWorkflowLogic() {
        return false;
    }

    public final boolean isGroovyLogic() {
        return FormulaNature.LIBRARY.equals(getFormulaNatureObject());
    }

    @Override
    public IFormulaNature getFormulaNatureObject() {
        return FormulaNature.getViaDBValue(getFormulaNature());
    }

    @Override
    public TypeDescriptor getDescriptor() {
        return TransformCalculationLogic.DESCRIPTOR;
    }
}

