package net.pricefx.logic.core.model.holders;

import net.pricefx.logic.core.model.ObjectHolder;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class WorkflowHolder extends ObjectHolder {
    public WorkflowHolder(Map<String, Object> holder) {
        super(holder);
    }

    public Map<String, Object> getWorkFlow() {
        return (Map<String, Object>) holder.get("workflow");
    }

    public List<WorkflowStepHolder> getSteps() {
        return ((List<Map<String, Object>>) getWorkFlow().get("steps"))
                .stream()
                .map(step -> new WorkflowStepHolder(step))
                .collect(Collectors.toList());
    }
}
